#(c) 2024 Christophe Gueneau
#Pour robot Maqueen Plus V2.1

from microbit import *
from time import sleep_ms
from machine import time_pulse_us

def initI2C():
        buf = bytearray(1)
        buf[0] = 0x32
        version=0
        while version==0:
            i2c.write(0x10, buf)
            version=(i2c.read(0x10, 1))[0]
        display.show("v"+ str(version))
        sleep(500)
        display.show(" ")

def moteur(dirG, vitG, dirD, vitD):
    buf = bytearray(5)
    buf[0] = 0x00
    buf[1] = dirG
    buf[2] = vitG
    buf[3] = dirD
    buf[4] = vitD
    i2c.write(0x10, buf)

def moteurG(dir, vit):
    buf = bytearray(3)
    buf[0] = 0x00
    buf[1] = dir
    buf[2] = vit
    i2c.write(0x10, buf)

def moteurD(dir, vit):
    buf = bytearray(3)
    buf[0] = 0x02
    buf[1] = dir
    buf[2] = vit
    i2c.write(0x10, buf)

def moteurStop():
    buf = bytearray(5)
    buf[0] = 0x00
    buf[1] = 0
    buf[2] = 0
    buf[3] = 0
    buf[4] = 0
    i2c.write(0x10, buf)

def ligne(indiceCapteur):
    buf = bytearray(1)
    buf[0] = 0x1D
    i2c.write(0x10, buf)
    etatByte = (i2c.read(0x10, 1)[0])               #on récupère l'octet d'index 0 dans le tableau
    etatCapteur = etatByte & 2**(indiceCapteur)    #masque
    if etatCapteur != 0:
        etatCapteur = 1
    return etatCapteur


def cptLigne():
    buf = bytearray(1)
    buf[0] = 0x1E
    i2c.write(0x10, buf)
    byte1 = (i2c.read(0x10, 2))               
    print(byte1[0])

def ledsAvant(choix, etat):
    buf = bytearray(3)
    if choix == 1:         
         buf[0] = 0x0B
         buf[1] = etat
         i2c.write(0x10, buf)    
    if choix == 0:
         buf[0] = 0x0C
         buf[1] = etat
         i2c.write(0x10, buf)    
    if choix == 2:       
         buf[0] = 0x0B
         buf[1] = etat
         buf[2] = etat
         i2c.write(0x10, buf)    


def distance():
    pinTrig = pin13
    pinEcho = pin14
    pinTrig.write_digital(1)
    sleep_ms(10)
    pinTrig.write_digital(0)
    pinEcho.read_digital()
    t = time_pulse_us(pinEcho, 1)
    d = 340 * t // 20000    
    if d <= 0:
        return 0
    if d > 500:
        return 500
    return d

moteur(0, 0, 0, 0)


